//sum two 8bit audio signals, without overflow
//hint: this is easier with intrinsics than it is in pure C
//note: you have to violate strict aliasing for this assignment, but this specific case (aliasing __m128i with something) must be supported by all compilers that support SSE intrinsics.
#include "functions.h"
#include "xmmintrin.h"
#include "smmintrin.h"

void calculateFunction(int8_t* a, int8_t* b, int8_t* c, int size) {
    for(size_t i = 0; i < size; ++i)
    {
        int sum = a[i] + b[i];
        if (sum > 127)
            sum = 127;
        if (sum < -128)
            sum = -128;
        c[i] = sum;
    }
}

void sseFunction(int8_t* a, int8_t* b, int8_t* c, int size) {
}
