//calculate x+5
#include "functions.h"
#include "xmmintrin.h"
#include "smmintrin.h"
void calculateFunction(float* a,float* b,int size){
    for(size_t i = 0; i < size; ++i)
    {
        b[i] = a[i]+5;
    }
}
void sseFunction(float* a, float* b, int size){
    int len = size/4;

    for(size_t i = 0; i < len; ++i)
    {
        // Load 4 floats to SSE register
        __m128 x = _mm_load_ps(a + 4 * i);
        __m128 temp;
        
        // Store 4 floats from SSE register
        _mm_store_ps(b + 4 * i, temp);
    }
}